/*
 * Copyright (C) 1997 and 1998 WIDE Project.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by WIDE Project and
 *    its contributors.
 * 4. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 *         ipv6cp.h
 *         created by copying and modifing ipcp.h
 *
 * $Id: ipv6cp.h,v 1.1.4.1 1998/04/20 13:03:03 shin Exp $
 *  
 */

/*
 *	    Written by Toshiharu OHNO (tony-o@iij.ad.jp)
 *
 *   Copyright (C) 1993, Internet Initiative Japan, Inc. All rights reserverd.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Internet Initiative Japan.  The name of the
 * IIJ may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id: ipv6cp.h,v 1.1.4.1 1998/04/20 13:03:03 shin Exp $
 *
 *	TODO:
 */

#ifndef _IPV6CP_H_
#define _IPV6CP_H_

#define	IPV6CP_MAXCODE	CODE_CODEREJ

#define	TY_IFID		1		/* Interface ID option */

#define IPV6CP_IFIDLEN 8
#define IPV6CP_IFIDSTRLEN 24
#define IPV6CP_IFIDP(x) ((char *)&(x) + (sizeof(x) - IPV6CP_IFIDLEN))

struct ipv6cpstate {
/* need to change to Interface ID ? */
  char his_ifid[IPV6CP_IFIDLEN];	/* Interface ID he is willing to use */

  char want_ifid[IPV6CP_IFIDLEN];	/* Interface ID I'm willing to use */

  u_long his_reject;		/* Request codes rejected by peer */
  u_long my_reject;		/* Request codes I have rejected */
};

extern struct ipv6cpstate Ipv6cpInfo;
extern struct in6_addr Ipv6MyAddress, Ipv6HisAddress;

extern void Ipv6cpInit(void);
extern void Ipv6cpUp(void);
extern void Ipv6cpOpen(void);
extern void Ipv6cpDefIfid(void);
extern int Ipv6cpOctetsIn(void);
extern int Ipv6cpOctetsOut(void);
extern int  ReportIpv6cpStatus(struct cmdargs const *arg);
extern void Ipv6cpAddInOctets(int);
extern void Ipv6cpAddOutOctets(int);
#endif /* _IPV6CP_H_ */
