/*-
 * Copyright (c) 1997 Brian Somers <brian@Awfulhak.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: log.h,v 1.1.1.2.2.1 1998/04/20 13:03:12 shin Exp $
 */

#define LogMIN		(1)
#define LogASYNC	(LogMIN)	/* syslog(LOG_INFO, ....)	 */
#define LogCARRIER	(LogASYNC + 1)
#define LogCCP		(LogCARRIER + 1)
#define LogCHAT		(LogCCP + 1)
#define LogCOMMAND	(LogCHAT + 1)
#define LogCONNECT	(LogCOMMAND + 1)
#define LogDEBUG	(LogCONNECT + 1)	/* syslog(LOG_DEBUG, ....)	 */
#define LogHDLC		(LogDEBUG + 1)
#define LogID0		(LogHDLC + 1)
#define LogIPCP		(LogID0 + 1)
#define LogIPV6CP	(LogIPCP + 1)
#define LogLCP		(LogIPV6CP + 1)
#define LogLINK		(LogLCP + 1)
#define LogLQM		(LogLINK + 1)
#define LogPHASE	(LogLQM + 1)
#define LogTCPIP	(LogPHASE + 1)
#define LogTUN		(LogTCPIP)	/* If set, tun%d is output with each message */
#define LogMAXCONF	(LogTUN)
#define LogWARN		(LogTUN + 1)	/* Sent to VarTerm else syslog(LOG_WARNING, ) */
#define LogERROR	(LogWARN + 1)	/* syslog(LOG_ERR, ....), + sent to VarTerm */
#define LogALERT	(LogERROR + 1)	/* syslog(LOG_ALERT, ....)	 */
#define LogMAX		(LogALERT)

/* The first int arg for all of the following is one of the above values */
extern const char *LogName(int);
extern void LogKeep(int);
extern void LogKeepLocal(int);
extern void LogDiscard(int);
extern void LogDiscardLocal(int);
extern void LogDiscardAll(void);
extern void LogDiscardAllLocal(void);
#define LOG_KEPT_SYSLOG (1)	/* Results of LogIsKept() */
#define LOG_KEPT_LOCAL  (2)	/* Results of LogIsKept() */
extern int LogIsKept(int);
extern void LogOpen(const char *);
extern void LogSetTun(int);
extern void LogClose(void);
extern void LogPrintf(int, const char *,...);
extern void LogDumpBp(int, const char *, const struct mbuf *);
extern void LogDumpBuff(int, const char *, const u_char *, int);
