/*
 * Copyright (C) 1997 and 1998 WIDE Project.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by WIDE Project and
 *    its contributors.
 * 4. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 *	    Written by Toshiharu OHNO (tony-o@iij.ad.jp)
 *
 *   Copyright (C) 1993, Internet Initiative Japan, Inc. All rights reserverd.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Internet Initiative Japan.  The name of the
 * IIJ may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id: mbuf.h,v 1.1.1.2.2.1 1998/04/20 13:03:18 shin Exp $
 *
 *	TODO:
 */

#ifndef _MBUF_H_
#define _MBUF_H_

struct mbuf {
  u_char *base;			/* pointer to top of buffer space */
  short size;			/* size allocated from base */
  short offset;			/* offset to start position */
  short cnt;			/* available byte count in buffer */
  short type;
  struct mbuf *next;		/* link to next mbuf */
  struct mbuf *pnext;		/* link to next packet */
};

struct mqueue {
  struct mbuf *top;
  struct mbuf *last;
  int qlen;
};

#define MBUF_CTOP(bp)   (bp->base + bp->offset)

#define MB_ASYNC	1
#define MB_FSM		(MB_ASYNC + 1)
#define MB_HDLCOUT	(MB_FSM + 1)
#define MB_IPIN		(MB_HDLCOUT + 1)
#define MB_IPV6IN	(MB_IPIN + 1)
#define MB_ECHO		(MB_IPV6IN + 1)
#define MB_LQR		(MB_ECHO + 1)
#define MB_MODEM	(MB_LQR + 1)
#define MB_VJCOMP	(MB_MODEM + 1)
#define	MB_LOG		(MB_VJCOMP + 1)
#define	MB_IPQ		(MB_LOG + 1)
#define	MB_IPV6Q	(MB_IPQ + 1)
#define	MB_MAX		MB_IPV6Q

extern int plength(struct mbuf * bp);
extern struct mbuf *mballoc(int cnt, int type);
extern struct mbuf *mbfree(struct mbuf * bp);
extern void pfree(struct mbuf * bp);
extern void mbwrite(struct mbuf * bp, u_char * ptr, int cnt);
extern struct mbuf *mbread(struct mbuf * bp, u_char * ptr, int cnt);
extern void DumpBp(struct mbuf * bp);
extern void Enqueue(struct mqueue * queue, struct mbuf * bp);
extern struct mbuf *Dequeue(struct mqueue * queue);
extern void LogMemory(void);
extern int ShowMemMap(struct cmdargs const *);
#endif /* _MBUF_H_ */
